alter table entry add extra VARCHAR null;
alter table entry add infostr7 VARCHAR_IGNORECASE null;
alter table entry add infostr8 VARCHAR_IGNORECASE null;


update entry set extra= '[' || nvl2(idtype,'{"type":"' || idtype || '"},','') || '{"builder":"' || casewhen(hasbuilder,'true','false') || '"}]' where url is not null;

CREATE INDEX ENTRY_PATH_IDX ON entry(path); 
CREATE INDEX ENTRY_FILENAME_IDX ON entry(filename); 


CALL FT_DROP_INDEX('PUBLIC', 'ENTRY');
CALL FT_CREATE_INDEX('PUBLIC', 'ENTRY', 'FILENAME, DESCRIPTION, ALLTAGS, INFOSTR1, INFOSTR2, INFOSTR3, INFOSTR4, INFOSTR5, INFOSTR6, INFOSTR7, INFOSTR8');  

CREATE TABLE CHORD  (ENTRYID INT NOT NULL,tuning ARRAY NOT NULL, root TINYINT NOT NULL default 0, positions ARRAY NOT NULL, label VARCHAR_IGNORECASE(50) NOT NULL default '', explicit BOOLEAN  NOT NULL default False) ;
COMMENT ON TABLE CHORD IS 'Chords such as found in the score';
ALTER TABLE CHORD ADD CONSTRAINT CHR_ENY_FK FOREIGN KEY (ENTRYID)REFERENCES ENTRY(ID) ON DELETE CASCADE;
ALTER TABLE CHORD ADD CONSTRAINT CHR_PK PRIMARY KEY(ENTRYID,tuning, root, positions,explicit);

CREATE INDEX CHR_IDX ON CHORD(entryid, root,positions, explicit); 
CREATE INDEX CHR_IDX2 ON CHORD(root,positions, explicit); 

CREATE TABLE CHORDBS  (ENTRYID INT NOT NULL, root TINYINT NOT NULL default 0, chord INT NOT NULL default 0, original BOOLEAN  NOT NULL default False) ;
COMMENT ON TABLE CHORDBS IS 'Chords decomposed into a bit set of contained notes';
ALTER TABLE CHORDBS ADD CONSTRAINT CHB_ENY_FK FOREIGN KEY (ENTRYID)REFERENCES ENTRY(ID) ON DELETE CASCADE;
ALTER TABLE CHORDBS ADD CONSTRAINT CHB_PK PRIMARY KEY(ENTRYID, root, chord, original);

CREATE INDEX CHB_IDX ON CHORDBS(entryid, root,chord, original); 
CREATE INDEX CHB_IDX2 ON CHORDBS(root,chord, original); 

CREATE TABLE SEARCHCHORDBS  (root TINYINT NOT NULL default 0, chord INT NOT NULL default 0, original BOOLEAN  NOT NULL default False) ;
COMMENT ON TABLE SEARCHCHORDBS IS 'Sought for Chords decomposed into a bit set of contained notes';
ALTER TABLE SEARCHCHORDBS ADD CONSTRAINT SCB_PK PRIMARY KEY(root, chord, original);

CREATE INDEX SCB_IDX ON SEARCHCHORDBS(root,chord, original); 


CREATE ALIAS matchChords FOR "com.zploger.db.ChordFunctions.matchChords";
CREATE ALIAS matchRoots FOR "com.zploger.db.ChordFunctions.matchRoots";

-- Des index en plus sur les hash
CREATE INDEX ENGH_IDXCOMB ON ENTRYTAGHASH(ENTRYID,COMBINAISON,HASH); 
CREATE INDEX ENGH_IDXHASH ON ENTRYTAGHASH(ENTRYID,HASH,COMBINAISON); 

insert into dbversion (scriptnr) values (320);